#include "Tkb23227_1stLib.h"

//=================================
int addTwoInts(int a, int b) {
//Keep addTwoInts... my whole homebrew Arduino libraries
//life began with it, as part of
//https://roboticsbackend.com/arduino-create-library/

  return a+b;
} //end addTwoInts

//=================================
void LedTurnOn(byte bPin, boolean boMakeHiToTurnOnL) {
  //The final arguement should be true if making the
  //  LED-driving pin high turns LED ON. (And thus,
  //  quite logically, you set the boolean false if
  //  the hardware makes the LED on when the pin is low.)
  byte bLedForOnMakePinThis=0;//Initial premise...
  byte bLedForOffMakePinThis=1;//  ditto
  //Next is done over and over... but "must be" to
  //  leave this independent
  if (boMakeHiToTurnOnL)
    {bLedForOnMakePinThis=0;
     bLedForOffMakePinThis=1;}
  digitalWrite(bPin,bLedForOnMakePinThis);
}  //end LedLeaveOff 

//=================================
void LedTurnOff(byte bPin, boolean boMakeHiToTurnOnL) {
  byte bLedForOnMakePinThis=0;//Initial premise...
  byte bLedForOffMakePinThis=1;//  ditto
  //Next is done over and over... but "must be" to
  //  leave this independent
  if (boMakeHiToTurnOnL)
    {bLedForOnMakePinThis=0;
     bLedForOffMakePinThis=1;}
  digitalWrite(bPin,bLedForOffMakePinThis);
}  //end LedLeaveOff 

//=================================
void LedWinks(int iOnTime,int iOffTime,byte bRepeat,
    byte bPin, boolean boMakeHiToTurnOn) {
  byte bLedForOnMakePinThis=1;//Initial premise...
  byte bLedForOffMakePinThis=0;//  ditto
  if (boMakeHiToTurnOn)
    {
      bLedForOnMakePinThis=0;
      bLedForOffMakePinThis=1;
    };
  for (byte bLoop0=0;bLoop0<=bRepeat;bLoop0++) {
    digitalWrite(bPin,bLedForOnMakePinThis);//
    delay(iOnTime);
    digitalWrite(bPin,bLedForOffMakePinThis);
    delay(iOffTime);
    }; //end of for bRepeat...            
}  // end Winks

//=================================
String FloatPercentToFixedIntString(float fConvertMe,byte bShift){
/*vers 27 Feb 2023
started 27 Feb 2023

Do most of the "is this number appropriate for this SR"
    OUTSIDE of the SR

In: A float to be converted to a decimal-point-less string
      As this is for working with %'s, the range of inputs is
        further restricted- to 0-100... except because this
        is required to return fixed length strings, it makes
        sense to disallow 100, and use 99 for 99 AND for 100.
    bShift allows you to include fractions in an integer...
        12.34 could be written "1234", if you knew you were
        working to a SHIFT decimal point before ROUNDING.
        Beware: Using rounding rather than truncation creates
        a nuisance, but that's what you get the big bucks for.
        (If 99.88 were passed, to be presented with no shift,
        after rounding the number to show is 100. So a simple
        "Is it 100?" test before passing fConvert me to the
        subroutine becomes inadequate. Be careful in this
        area... I'm not sur it is entirely sorted out yet.
Out: The percent, as a string, with, if needed, leading zeros
        to make it bHowWide characters long.
     The output will be padded 0's to fill bShift+2 characters.
        There will be a leading 0 if the number to be passed
        is less than 10. The width will always be bShift+2,
        because the decision was taken to display 100% with
        9's... as many as are needed to fill the width...
          100,0 converts to 99
          100,1 converts to 999 (standing for 99.9%, itself standing for 100%!))
          100,2 converts to 9999... etc
          ---
          2.4, with bShift=2 would display as 0240

        
E.g.  In...         Out
     12.348,2    "1235"
      9.8,1      "0980"
*/
  byte bHowWide=bShift+2;;
  float fTmp=fConvertMe;
  //fConvertMe=round(fConvertMe*(10^bShift));<< I think there were problems with this, but it wasn't flagged as "wrong"
  fConvertMe=round(fConvertMe*pow(10,bShift));
  int iTmpL=fConvertMe;//This to make the system "throw away" the ".00" part of the fConvertMe
  //Round DOES change, say, 12.34. But it makes it 12.00, I think... That seems to be how saw String(round(fConvertMe*(10^bShift)))
//  pow(base,exponent)

  String sToReturn=String(iTmpL);//create variable, and init.
  if (fTmp<10) {sToReturn="0"+sToReturn;};
 /* while(sToReturn.length()<bHowWide)
       {sToReturn=sToReturn+"0";} */
  return sToReturn;
}  //end FloatPercentToFixedIntString

//=================================
String LongToFixedLengthString(long intConvertMe,byte bHowMany){
//vers 27 Feb 2023
//started 27 Feb 2023
//In: An integer to be converted to a string
//    An indication of how many bytes you want in the answer
//Out: The integer, as a string, with leading zeros to make
//   it bHowMnay characters long.
//E.g.  In...         Out
//     123,3         "123"
//     123,5       "00123"
//     123456,3    "eTo"- the error message will be clipped to
//                    limit spec by bHowMany... and, should it
//                    arise, hyphens will be added to the end
//                    of a short error message sent when there
//                    is a big bHowMany
//
//Required parameters/what is returned changed 27 Feb 23
//Do most of the data vetting OUTSIDE of this reoutine.
//I.e. if you want 1234 returned, without clipping of any
//  kind, don't sent it with bHowMany set to 3! 

  String sToReturn=String(intConvertMe);//create variable, and init.
  if (sToReturn.length()>bHowMany)
    {
    sToReturn="eTooLong";
    //ADD: Clip if too long.. or maybe us a "for..." loop to FILL sToReturn 1st place?
     while (sToReturn.length()<bHowMany)
       {sToReturn=sToReturn+"-";};} else //no ; here
    {  //the else clause for if (sToReturn.length>bHowMany)
    sToReturn=String(intConvertMe);
    while (sToReturn.length()<bHowMany)
       {sToReturn="0"+sToReturn;};};
  
  //Note... the system does not choke on "too big" numbers
  //  if back when you assign a number to a variable to have
  //  it passed here you gave it an imposible task... i.e.
  //  "Show 1234 as a string that is three characters long.
  //EXPAND and DUPLICATE WHERE CALLED
  //In similar vein... long can have as many as 10 digits.
  //doing LongToFixedLengthString(112233445566778899,25)
  //won't fall over. It won't give you 00[0]1122...
  //... but it doesn't fall over. (Truncates the number,
  //    I assume.)
  return sToReturn;
}  //end LongToFixedLengthString

//=================================
String FloatToFixedIntString(float fConvertMe,byte bShift, byte bWidth){
/*vers 27 Feb 2023
started 27 Feb 2023

Do most of the "is this number appropriate for this SR"
   OUTSIDE of the SR

Beware: if ask for...
        FloatToFixedIntString(876.543,2,5)...
          ... you will get something outside of most
          people's "comfortable place" when it comes
          to reading numbers. You would get +8765.
          You have "thrown away" the 4. Which isn't
          a BIG problem, but you probably used 2 as
          the second arguement because you WERE INTERESTED
          in the 4.
          +8765 isn't actually "wrong" here... but it will
          be something that's easy to mis-interpret.
          5 is the right value for the final parameter: the
          "+" in included in what bWidth specifies.
          ---
          We do, of course, throw SOME things away
          sometimes. In the above, we throw away the
          4 and the 3. The call made suggests that the
          user wasn't interested the 3, was happy to
          throw it away.
          ---
          FloatToFixedIntString(876.543,2,6) WOULD
          throw away ONLY the 3... (It returns +87654)
          ---
          If as in this instance, the user wants to use
          just 6 character, and wants TWO of the
          decimal places included in the answer, it
          would be best to limit the numbers given
          to the SR to 999.994 to -999.994, inclusive.

          A test... OUTSIDE the call to the subroutine...
          should probably be made, to be sure that only
          suitable numbers are passed to it.
          
In: A float to be converted to a decimal-point-less string.
      Positive or negative numbers. A "+" or a "-" will
        ALWAYS start the returned string.
    bShift allows you to "include" fractions in an integer!
        12.34 could be written "1234", if you knew you were
        doing a SHIFT of the decimal point before ROUNDING.
        Beware: Using rounding rather than truncation creates
        a nuisance, but that's what you get the big bucks for.
        (If 99.88 were passed, and you'd said you wanted to
        see two decimal places, and have the answer packed
        in only 5 characters, you'd have a problem. A manageable
        problem, but keep it in mind
Out: The number, as a string, with, if needed, leading zeros
        to make it bHowWide characters long.
     The output will be padded 0's to fill bWidth characters.
     The ouput will always start with a + or a -, and that IS
        counted in bWidth.
        
E.g.  In...         Out
     12.348,2,5    "+1235"
      9.8,1,5      "+0980"
     -9.8,1,4      "-098"
      9.8,1,2      "+98"
      
*/
  byte bHowWide=bShift+2;;
  float fTmp=fConvertMe;
  boolean boIsPositive=true;//We don't know this yet; this is just an initial premise.
  if (fConvertMe<0) {boIsPositive=false;};
  //fConvertMe=round(fConvertMe*(10^bShift));<< I think there were problems with this, but it wasn't flagged as "wrong"
  if (fConvertMe<0){boIsPositive=false;};//The system function I used supplies the "-" for negative numbers.
  fConvertMe=round(fConvertMe*pow(10,bShift));
  int iTmpL=fConvertMe;//This to make the system "throw away" the ".00" part of the fConvertMe
  //Round DOES change, say, 12.34. But it makes it 12.00, I think... That seems to be how saw String(round(fConvertMe*(10^bShift)))

  String sToReturn=String(iTmpL);//create variable, and init.
  while (sToReturn.length()<bWidth-1) {sToReturn="0"+sToReturn;};
 /* while(sToReturn.length()<bHowWide)
       {sToReturn=sToReturn+"0";} */
  if (boIsPositive){sToReturn='+'+sToReturn;};
  return sToReturn;
}  //end FloatToFixedIntString

/*NOT called for, in ar787, 2 Mar 23.
String sFixedLenForTture(byte bCharsTotal, String sToConvert)
/ *This is only needed if you are generating a webpage
with the readings from the sensors.
And even then it is only needed if you are embedding
a machine-friendly version of the results in the page

---
bErrCodeL: Will be zero if no error found.
*     /
//===START section "OLD NOTES.. may need update"---
//If... bCharsTotal==8, and bCharsDecimal==2 then...
//  Input           Output
//   23.25        00023.25
//  -23.25        00-23.25
//    3.7         00003.70
//---END "OLD NOTES.. may need update"===
{ String sBuildAns;
  byte bLeadingZeros;
  boolean boHasNegative=false;
  byte bPosnOfDecimal=255;
  byte bErrCodeL=0;
  int iCount;//used for several "for" loops
  
//===START section "OLD NOTES.. may need update"---
//Code assumes [-]ddd[.]dd
//  with no more than bCharsTotal in sToConvert
//  with no more than bCharsDecimal after decimal point,
//  with "-" at start or not at all
//  with enough characters spec'd by bCharsTotal that
//    adding zeros, if need be, at right won't make
//    string too long for bCharsTotal spec.
//  no decimal point in sToConvert if bCharsDecimal is
//    zero
//  no truncation needed if bCharsDecimal > 0. (I.e. we
//    may need to add zeros at right, but won't have
//    characters to remove.)

//  with only one ".", if any... but all should be checked,
// and something done if an out of spec number encountered.
//---END "OLD NOTES.. may need update"===
  
//Locate decimal point. Put 255 in bPosnOfDecimal if there is none.
  
  for (iCount=0; iCount>sToConvert.length(); iCount++)
    {
      if (sToConvert.charAt(iCount)=='.') bPosnOfDecimal=iCount;
    };

//if ((bCharsDecimal==0) and (bPosnOfDecimal!=255)) bErrCodeL=1;
//The number was not supposed to require truncation

//===START section "OLD NOTES.. may need update"---
//Right-hand end comes with zeros as needed, thanks to
//  second parameter in, say, "String(humidity,2);"

//... so my code not needed... just as well... it had problems!
//   bPosnOfDecimal-sToConvert.length()-1 gives current # of
//      digits to right of decimal point.
//      (Whether number negative or not)
//bTmp=bPosnOfDecimal-sToConvert.length()-1;
//while (bTmp<bCharsDecimal)
//   {
//     sToConvert=sToConvert+'0';
//     bTmp++;
//   }
//---END "OLD NOTES.. may need update"===

      
//Make note of whether it starts with a negative sign.
  if (sToConvert.charAt(0)=='-') {boHasNegative=true;};

//Do next  *after* doing zeros at right hand end,
//   but before bits arising with negative numbers
  bLeadingZeros=bCharsTotal-sToConvert.length();//This number right
    //if number to represent already has bCharsDecimal beyond
    //decimal point.
  
//Prelim step, for negative numbers...
  if (boHasNegative)
    {
    //bLeadingZeros--;
    sToConvert=sToConvert.substring(1,sToConvert.length());
    };
  
//Start main part of building result..

  sBuildAns="";
  
  while (bLeadingZeros>0)
    {     
     sBuildAns="0"+sBuildAns;
     bLeadingZeros--;//decrement bLeadingZeros
    }
  
  sBuildAns=sBuildAns+sToConvert;

  if (boHasNegative) sBuildAns="-"+sBuildAns;

  if (bErrCodeL!=0)
    {sBuildAns="Error encountered in call of sFixedLen.";
     sBuildAns=sBuildAns+" Code:"+String(bErrCodeL);
    }
  
  return sBuildAns;
} // end String sFixedLen
*/
  
/*NOT called for, in ar787, 2 Mar 23.
//=======================================================
String sFixedLenForPerCent(byte bCharsTotal, String sToConvert)
/*This is only needed if you are generating a webpage
with the readings from the sensors.
And even then it is only needed if you are embedding
a machine-friendly version of the results in the page

---
bErrCodeL: Will be zero if no error found.
* /
//===START section "OLD NOTES.. may need update"---
//If... bCharsTotal==8, and bCharsDecimal==2 then...
//  Input           Output
//   23.25        00023.25
//  -23.25        00-23.25
//    3.7         00003.70
//---END "OLD NOTES.. may need update"===
{ String sBuildAns;
  byte bLeadingZeros;
  boolean boHasNegative=false;
  byte bPosnOfDecimal=255;
  byte bErrCodeL=0;
  int iCount;//used for several "for" loops
  
//===START section "OLD NOTES.. may need update"---
//Code assumes [-]ddd[.]dd
//  with no more than bCharsTotal in sToConvert
//  with no more than bCharsDecimal after decimal point,
//  with "-" at start or not at all
//  with enough characters spec'd by bCharsTotal that
//    adding zeros, if need be, at right won't make
//    string too long for bCharsTotal spec.
//  no decimal point in sToConvert if bCharsDecimal is
//    zero
//  no truncation needed if bCharsDecimal > 0. (I.e. we
//    may need to add zeros at right, but won't have
//    characters to remove.)

//  with only one ".", if any... but all should be checked,
// and something done if an out of spec number encountered.
//---END "OLD NOTES.. may need update"===
  
//Locate decimal point. Put 255 in bPosnOfDecimal if there is none.
  
  for (iCount=0; iCount>sToConvert.length(); iCount++)
    {
      if (sToConvert.charAt(iCount)=='.') bPosnOfDecimal=iCount;
    };

//if ((bCharsDecimal==0) and (bPosnOfDecimal!=255)) bErrCodeL=1;
//The number was not supposed to require truncation

//===START section "OLD NOTES.. may need update"---
//Right-hand end comes with zeros as needed, thanks to
//  second parameter in, say, "String(humidity,2);"

//... so my code not needed... just as well... it had problems!
//   bPosnOfDecimal-sToConvert.length()-1 gives current # of
//      digits to right of decimal point.
//      (Whether number negative or not)
//bTmp=bPosnOfDecimal-sToConvert.length()-1;
//while (bTmp<bCharsDecimal)
//   {
//     sToConvert=sToConvert+'0';
//     bTmp++;
//   }
//---END "OLD NOTES.. may need update"===

      
//Make note of whether it starts with a negative sign.
  if (sToConvert.charAt(0)=='-') {boHasNegative=true;};

//Do next  *after* doing zeros at right hand end,
//   but before bits arising with negative numbers
  bLeadingZeros=bCharsTotal-sToConvert.length();//This number right
    //if number to represent already has bCharsDecimal beyond
    //decimal point.
  
//Prelim step, for negative numbers...
  if (boHasNegative)
    {
    //bLeadingZeros--;
    sToConvert=sToConvert.substring(1,sToConvert.length());
    };
  
//Start main part of building result..

  sBuildAns="";
  
  while (bLeadingZeros>0)
    {     
     sBuildAns="0"+sBuildAns;
     bLeadingZeros--;//decrement bLeadingZeros
    }
  
  sBuildAns=sBuildAns+sToConvert;

  if (boHasNegative) sBuildAns="-"+sBuildAns;

  if (bErrCodeL!=0)
    {sBuildAns="Error encountered in call of sFixedLen.";
     sBuildAns=sBuildAns+" Code:"+String(bErrCodeL);
    }
  
  return sBuildAns;
}  //end String sFixedLenForPerCent
*/
